from signal import SIGRTMIN, SIGTERM, pthread_kill, signal
from sys import exit
from threading import enumerate as th_enumerate

class SignalRouter:
    def term(self, sig, frame):
        print("Term signal received! Safely closing threads!")
        for thread in th_enumerate():
            pthread_kill(thread.ident, SIGTERM)

    def __init__(self):
        signal(SIGTERM, self.term)
        signal(SIGRTMIN, self.rtmin)
